﻿using GHIElectronics.TinyCLR.Pins;
using System;
using System.Diagnostics;
using System.Threading;

namespace TCLR_PANDA3_STEPPER
{
    class Program
    {
        static void Main()
        {
            // Test for stepper motor ITC-VNC-2  N=200steps - U=12V - C=200g/cm
            var time = 2000; UInt16 delay = 5; UInt32 nbpas = 200;
            var stepper = new EasyStepperDriver(FEZPandaIII.GpioPin.D13, FEZPandaIII.GpioPin.D12, FEZPandaIII.GpioPin.D2, FEZPandaIII.GpioPin.D10, FEZPandaIII.GpioPin.D11, FEZPandaIII.GpioPin.D3);

            stepper.WakeUp();

            while (true)
            {   // Using Step(), StepMode, StepDirection and Steptime
                stepper.EnableOutputs();
                Debug.WriteLine("Sleep= " + stepper.IsDriverSleep + " Enable= " + stepper.IsOutputsEnable);
                Debug.WriteLine("Full Forward"); // 360° for ITC-VNC-1 motor
                stepper.Turn(nbpas, EasyStepperDriver.Direction.Forward, delay, EasyStepperDriver.Mode.Full);
                Debug.WriteLine("Steps= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.DisableOutputs(); Thread.Sleep(time);

                Debug.WriteLine("Half Backward"); stepper.EnableOutputs(); // 180° for ITC-VNC-1 motor
                stepper.Turn(nbpas, EasyStepperDriver.Direction.Backward, delay, EasyStepperDriver.Mode.Half);
                Debug.WriteLine("Steps= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.DisableOutputs(); Thread.Sleep(time);

                Debug.WriteLine("Quater Forward"); stepper.EnableOutputs();  // 90° for ITC-VNC-1 motor
                stepper.Turn(nbpas, EasyStepperDriver.Direction.Forward, delay, EasyStepperDriver.Mode.Quarter);
                Debug.WriteLine("Steps= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.DisableOutputs(); Thread.Sleep(time);

                Debug.WriteLine("OneEighth Backward"); stepper.EnableOutputs(); // 45° for ITC-VNC-1 motor
                stepper.Turn(nbpas, EasyStepperDriver.Direction.Backward, 1, EasyStepperDriver.Mode.OneEighth);
                Debug.WriteLine("Steps= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.DisableOutputs(); Thread.Sleep(3 * time);
            }
        }
    }
}
